<div class="col-sm-6 style-form">
  <h2>Register</h2>
  <form [formGroup]="registerForm" (ngSubmit)="onSubmit(registerForm.value)">
    <div class="form-group">
      <label for="firstname">Firstname</label>
      <input type="text" formControlName="firstname" class="form-control style-input"
        [ngClass]="{ 'is-invalid': submitted && f.firstname.errors }" />
      <div *ngIf="submitted && f.firstname.errors" class="invalid-feedback">
        <div *ngIf="f.firstname.errors.required">Firstname is required</div>
      </div>
    </div>
    <div class="form-group">
      <label for="lastname">Lastname</label>
      <input type="text" formControlName="lastname" class="form-control style-input"
        [ngClass]="{ 'is-invalid': submitted && f.lastname.errors }" />
      <div *ngIf="submitted && f.lastname.errors" class="invalid-feedback">
        <div *ngIf="f.lastname.errors.required">Lastname is required</div>
      </div>
    </div>
    <div class="form-group">
      <label>Email</label>
      <input type="text" formControlName="email" class="form-control style-input"
        [ngClass]="{ 'is-invalid': submitted && f.email.errors }" />
      <div *ngIf="submitted && f.email.errors" class="invalid-feedback">
        <div *ngIf="f.email.errors.required">Email is required</div>
        <div *ngIf="f.email.errors.email">Email must be a valid email address</div>
      </div>
    </div>
    <div class="form-group">
      <label for="password">Password</label>
      <input type="password" formControlName="password" class="form-control style-input"
        [ngClass]="{ 'is-invalid': submitted && f.password.errors }" />
      <div *ngIf="submitted && f.password.errors" class="invalid-feedback">
        <div *ngIf="f.password.errors.required">Password is required</div>
        <div *ngIf="f.password.errors.pattern">
          <ul style="margin-left: 15px;">
            <li>At least 8 characters in length</li>
            <li>Start with the letter</li>
            <li>Lowercase letters</li>
            <li>Uppercase letters</li>
            <li>Numbers</li>
            <li>Special characters</li>
          </ul>
        </div>
      </div>
    </div>
    <div class="form-group">
      <button [disabled]="loading" class="btn btn-primary">
        <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
        Register
      </button>
      <a routerLink="/login" class="btn btn-link">Cancel</a>
    </div>
  </form>
</div>
